<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RoomInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RoomInfo extends AbstractStructArrayBase
{
    /**
     * The JPRoom
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RoomInfo[]
     */
    public $JPRoom;
    /**
     * Constructor method for ArrayOfJP_RoomInfo
     * @uses ArrayOfJP_RoomInfo::setJPRoom()
     * @param \StructType\JP_RoomInfo[] $jPRoom
     */
    public function __construct(array $jPRoom = array())
    {
        $this
            ->setJPRoom($jPRoom);
    }
    /**
     * Get JPRoom value
     * @return \StructType\JP_RoomInfo[]|null
     */
    public function getJPRoom()
    {
        return $this->JPRoom;
    }
    /**
     * Set JPRoom value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RoomInfo[] $jPRoom
     * @return \ArrayType\ArrayOfJP_RoomInfo
     */
    public function setJPRoom(array $jPRoom = array())
    {
        foreach ($jPRoom as $arrayOfJP_RoomInfoJPRoomItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RoomInfoJPRoomItem instanceof \StructType\JP_RoomInfo) {
                throw new \InvalidArgumentException(sprintf('The JPRoom property can only contain items of \StructType\JP_RoomInfo, "%s" given', is_object($arrayOfJP_RoomInfoJPRoomItem) ? get_class($arrayOfJP_RoomInfoJPRoomItem) : gettype($arrayOfJP_RoomInfoJPRoomItem)), __LINE__);
            }
        }
        $this->JPRoom = $jPRoom;
        return $this;
    }
    /**
     * Add item to JPRoom value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RoomInfo $item
     * @return \ArrayType\ArrayOfJP_RoomInfo
     */
    public function addToJPRoom(\StructType\JP_RoomInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RoomInfo) {
            throw new \InvalidArgumentException(sprintf('The JPRoom property can only contain items of \StructType\JP_RoomInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->JPRoom[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RoomInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RoomInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RoomInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RoomInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RoomInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string JPRoom
     */
    public function getAttributeName()
    {
        return 'JPRoom';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_RoomInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
